library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library UNISIM;
use UNISIM.VComponents.all;

entity AD936x_FMC_PinWrapper is
	port (	------------------------------
				-- FMC (LPC) Connektor Pins --
				------------------------------
				TRST_L			: inout std_logic;
				PRSNT_M2C_L		:    in std_logic;
				PG_C2M			:   out std_logic;
				DP0_C2M_P		:   out std_logic;
				DP0_C2M_N		:   out std_logic;
				DP0_M2C_P		:    in std_logic;
				DP0_M2C_N		:    in std_logic;
				CLK0_M2C_P		:    in std_logic;
				CLK0_M2C_N		:    in std_logic;
				GBTCLK0_M2C_P	:    in std_logic;
				GBTCLK0_M2C_N	:    in std_logic;
				CLK1_M2C_P		:    in std_logic;
				CLK1_M2C_N		:    in std_logic;
				LA00_P_CC		: inout std_logic;
				LA00_N_CC		: inout std_logic;
				LA01_P_CC		: inout std_logic;
				LA01_N_CC		: inout std_logic;
				LA02_P			: inout std_logic;
				LA02_N			: inout std_logic;
				LA03_P			: inout std_logic;
				LA03_N			: inout std_logic;
				LA04_P			: inout std_logic;
				LA04_N			: inout std_logic;
				LA05_P			: inout std_logic;
				LA05_N			: inout std_logic;
				LA06_P			: inout std_logic;
				LA06_N			: inout std_logic;
				LA07_P			: inout std_logic;
				LA07_N			: inout std_logic;
				LA08_P			: inout std_logic;
				LA08_N			: inout std_logic;
				LA09_P			: inout std_logic;
				LA09_N			: inout std_logic;
				LA10_P			: inout std_logic;
				LA10_N			: inout std_logic;
				LA11_P			: inout std_logic;
				LA11_N			: inout std_logic;
				LA12_P			: inout std_logic;
				LA12_N			: inout std_logic;
				LA13_P			: inout std_logic;
				LA13_N			: inout std_logic;
				LA14_P			: inout std_logic;
				LA14_N			: inout std_logic;
				LA15_P			: inout std_logic;
				LA15_N			: inout std_logic;
				LA16_P			: inout std_logic;
				LA16_N			: inout std_logic;
				LA17_P_CC		: inout std_logic;
				LA17_N_CC		: inout std_logic;
				LA18_P_CC		: inout std_logic;
				LA18_N_CC		: inout std_logic;
				LA19_P			: inout std_logic;
				LA19_N			: inout std_logic;
				LA20_P			: inout std_logic;
				LA20_N			: inout std_logic;
				LA21_P			: inout std_logic;
				LA21_N			: inout std_logic;
				LA22_P			: inout std_logic;
				LA22_N			: inout std_logic;
				LA23_P			: inout std_logic;
				LA23_N			: inout std_logic;
				LA24_P			: inout std_logic;
				LA24_N			: inout std_logic;
				LA25_P			: inout std_logic;
				LA25_N			: inout std_logic;
				LA26_P			: inout std_logic;
				LA26_N			: inout std_logic;
				LA27_P			: inout std_logic;
				LA27_N			: inout std_logic;
				LA28_P			: inout std_logic;
				LA28_N			: inout std_logic;
				LA29_P			: inout std_logic;
				LA29_N			: inout std_logic;
				LA30_P			: inout std_logic;
				LA30_N			: inout std_logic;
				LA31_P			: inout std_logic;
				LA31_N			: inout std_logic;
				LA32_P			: inout std_logic;
				LA32_N			: inout std_logic;
				LA33_P			: inout std_logic;
				LA33_N			: inout std_logic;
				SCL				: inout std_logic;
				SDA				: inout std_logic;
				---------------------
				-- control signals --
				---------------------
				-- status info --
				FMC_Plugged		:   out std_logic;								
				-- AD936x register interface --
				AD_CE				:    in std_logic;								
				AD_MISO			:   out std_logic;								
				AD_MOSI			:    in std_logic;								
				AD_SCLK			:    in std_logic;								
				-- AD936x data interface --
				AD_Enable		:    in std_logic;								
				AD_ResetB		:    in std_logic;								
				AD_Data_Clk		:   out std_logic;  										
				AD_FB_Clk		:    in std_logic;								
				AD_Data_Rx		:   out std_logic_vector(11 downto 0);		
				AD_Data_Tx		:    in std_logic_vector(11 downto 0);		
				AD_Rx_Frame		:   out std_logic;								
				AD_Tx_Frame		:    in std_logic;								
				AD_TxNRx			:    in std_logic;								
				AD_En_AGC		:    in std_logic;								
				AD_Ctrl_Out		:   out std_logic_vector(7 downto 0);		
				AD_Ctrl_In		:    in std_logic_vector(3 downto 0);     
				AD_Sync_In		:    in std_logic;								
				AD_ClkOut		:   out std_logic);								
end AD936x_FMC_PinWrapper;

architecture Behavioral of AD936x_FMC_PinWrapper is
begin
	
	------------------------------------------------
	-- Outputs to Carrier Board (CMOS / FDD Mode) --
	------------------------------------------------

	LA16_P		<= AD_Enable;							-- enable module
	LA28_P		<= AD_ResetB;							-- asynchronous reset, active low

	LA08_P		<= AD_FB_Clk;
	LA08_N		<= '0';

	LA09_P		<= AD_Tx_Frame;
	LA09_N		<= '0';
	
	LA02_N		<= AD_Data_Tx(0);						
	LA02_P		<= AD_Data_Tx(1);						
	LA03_N		<= AD_Data_Tx(2);						
	LA03_P		<= AD_Data_Tx(3);						
	LA04_N		<= AD_Data_Tx(4);						
	LA04_P		<= AD_Data_Tx(5);						
	LA05_N		<= AD_Data_Tx(6);						
	LA05_P		<= AD_Data_Tx(7);						
	LA06_N		<= AD_Data_Tx(8);						
	LA06_P		<= AD_Data_Tx(9);						
	LA07_N		<= AD_Data_Tx(10);					
	LA07_P		<= AD_Data_Tx(11);					
					
	LA16_N		<= AD_TxNRx;							
	LA19_P		<= AD_En_AGC; 							
	LA24_P		<= AD_Ctrl_In(0); 					
	LA24_N		<= AD_Ctrl_In(1); 					
	LA25_P		<= AD_Ctrl_In(2); 					
	LA25_N		<= AD_Ctrl_In(3); 					
	LA19_N		<= AD_Sync_In;							
	 
	LA26_P		<= AD_CE;								
	LA27_P 		<= AD_MOSI; 							
	LA26_N		<= AD_SCLK;								
	 
	 
	-------------------------------------------------
	-- Inputs from Carrier Board (CMOS / FDD Mode) --
	-------------------------------------------------
	
	FMC_Plugged 	<= not PRSNT_M2C_L;				-- Carrier Board plugged

	AD_Data_Clk		<= LA00_P_CC;						
	AD_Rx_Frame		<= LA01_P_CC;						
	
	AD_Data_Rx(0) 	<= LA11_N;							
	AD_Data_Rx(1) 	<= LA11_P;							
	AD_Data_Rx(2) 	<= LA12_N;							
	AD_Data_Rx(3) 	<= LA12_P;							
	AD_Data_Rx(4) 	<= LA13_N;							
	AD_Data_Rx(5) 	<= LA13_P;							
	AD_Data_Rx(6) 	<= LA10_N;							
	AD_Data_Rx(7) 	<= LA10_P;							
	AD_Data_Rx(8) 	<= LA14_N;							
	AD_Data_Rx(9) 	<= LA14_P;							
	AD_Data_Rx(10) <= LA15_N;							
	AD_Data_Rx(11) <= LA15_P;							
	
	AD_Ctrl_Out(0) <= LA20_P;							
	AD_Ctrl_Out(1) <= LA20_N;							
	AD_Ctrl_Out(2) <= LA21_P;							
	AD_Ctrl_Out(3) <= LA21_N;							
	AD_Ctrl_Out(4) <= LA22_P;							
	AD_Ctrl_Out(5) <= LA22_N;							
	AD_Ctrl_Out(6) <= LA23_P;							
	AD_Ctrl_Out(7)	<= LA23_N;							
	AD_ClkOut   	<= CLK0_M2C_P;						
		
	AD_MISO 			<= LA27_N;							

	-- set inputs to High-Z --
	LA00_P_CC		<= 'Z';
	LA00_N_CC		<= 'Z';
	LA01_P_CC		<= 'Z';
	LA01_N_CC		<= 'Z';
	LA11_P			<= 'Z';
	LA11_N			<= 'Z';
	LA12_P			<= 'Z';
	LA12_N			<= 'Z';
	LA13_P			<= 'Z';
	LA13_N			<= 'Z';
	LA10_P			<= 'Z';
	LA10_N			<= 'Z';
	LA14_P			<= 'Z';
	LA14_N			<= 'Z';
	LA15_P			<= 'Z';
	LA15_N			<= 'Z';
	LA20_P			<= 'Z';
	LA20_N			<= 'Z';
	LA21_P			<= 'Z';
	LA21_N			<= 'Z';
	LA22_P			<= 'Z';
	LA22_N			<= 'Z';
	LA23_P			<= 'Z';
	LA23_N			<= 'Z';
	LA27_N			<= 'Z';
	
	
	--------------------------
	-- static & unused Pins --
	--------------------------
	
	TRST_L			<= '0';
	PG_C2M			<= '1';		-- activate power on fmc
	DP0_C2M_P		<= '0';
	DP0_C2M_N		<= '0';
	LA17_P_CC		<= 'Z';
	LA17_N_CC		<= 'Z';
	LA18_P_CC		<= 'Z';
	LA18_N_CC		<= 'Z';
	LA28_N			<= 'Z';
	LA29_P			<= 'Z';
	LA29_N			<= 'Z';
	LA30_P			<= 'Z';
	LA30_N			<= 'Z';
	LA31_P			<= 'Z';
	LA31_N			<= 'Z';
	LA32_P			<= 'Z';
	LA32_N			<= 'Z';
	LA33_P			<= 'Z';
	LA33_N			<= 'Z';
	SCL				<= 'Z';
	SDA				<= 'Z';


end Behavioral;

